package	jp.co.sds_corp.util.pooh.simple;

import java.awt.BorderLayout;

import javax.swing.JDialog;
import javax.swing.JFrame;
import javax.swing.JPanel;

import jp.co.sds_corp.util.pooh.dialog.DialogResource;
import jp.co.sds_corp.util.pooh.pane.ChildPane;
import jp.co.sds_corp.util.pooh.pane.CustButton;
import jp.co.sds_corp.util.pooh.top.Toplevel;

public class SimpleDialog extends JDialog {
	DialogResource dialogResource = null;
	int action = -1;

	public void setAction(int idx) { action = idx; }
	public int getAction() { return action; }

	public SimpleDialog(Toplevel toplevel, DialogResource request) throws Exception {
		super((JFrame)toplevel.getFrame(), request.getDialog_name(), request.getDialog_style());
		dialogResource = request;
		setBounds(toplevel.getPreferredDialogRectangle(request.getDialog_x(),request.getDialog_y()
												,request.getDialog_w(), request.getDialog_h()));
		ChildPane  childPane = null;
		CustButton custBtn   = null;

		custBtn = (CustButton)request.getCustbtn();
		custBtn.createButton(this, request.getDialog_btns());

		childPane = (ChildPane)request.getPanel();
		if (childPane != null) {
			((SimplePanel)childPane).setParent(toplevel, this, custBtn, dialogResource);
			childPane.createPane();
			getContentPane().setLayout(new BorderLayout());
			getContentPane().add((JPanel)childPane, "Center");
		}

		getContentPane().add((JPanel)custBtn, "South");
		setResizable(request.getDialog_resize());
	}

	public ChildPane getChildPane() {return (ChildPane)dialogResource.getPanel();}
	public CustButton getCustButton() {return (CustButton)dialogResource.getCustbtn();}
	public DialogResource getDialogResource() { return dialogResource; }
	private void closedByClick() { 
		if (dialogResource.getPanel() != null)
			((ChildPane)dialogResource.getPanel()).closed();
		((CustButton)dialogResource.getCustbtn()).closed();
	}
	public void closed() { closedByClick(); }
}
