package	jp.co.sds_corp.util.pooh.simple;

import java.awt.Component;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;

import javax.swing.JMenuItem;
import javax.swing.event.PopupMenuEvent;
import javax.swing.event.PopupMenuListener;

import jp.co.sds_corp.util.pooh.frame.FrameResource;
import jp.co.sds_corp.util.pooh.menu.RootMenuResource;
import jp.co.sds_corp.util.pooh.menu.SubMenuResource;
import jp.co.sds_corp.util.pooh.popup.IPopup;
/**
*
*/
public class SimplePopup implements PopupMenuListener, ActionListener {
	private IPopup popup = null;
	private SimplePopupMenu popupMenu = null;
	private SimpleMouseListener simpleMouseListener = null;
	private Object actionSource = null;

	public SimplePopup(RootMenuResource resource) {
		popupMenu = new SimplePopupMenu(this, resource);
		popupMenu.addPopupMenuListener(this);
		simpleMouseListener = new SimpleMouseListener(this);
	}

	public SimplePopup(IPopup _popup) {
		popupMenu = new SimplePopupMenu(this, _popup.getPopupMenuItem());
		popupMenu.addPopupMenuListener(this);
		simpleMouseListener = new SimpleMouseListener(this);
		Component c = _popup.getComponent();
		if (c != null) { c.addMouseListener(simpleMouseListener); }
		popup = _popup;
	}
	public void setActionListener(IPopup _popup) { 
		Component c = _popup.getComponent();
		if (c != null) { c.addMouseListener(simpleMouseListener); }
		popup = _popup; 
	}

	public void addPopupListener(Component c) {
		c.addMouseListener(simpleMouseListener);
	}

	public void setEnabled(boolean b, int index) {
		popupMenu.getComponent(index).setEnabled(b);
	}

	public SimplePopup(IPopup _popup, Object[][] m) {
		popupMenu = new SimplePopupMenu(this, m);
		popupMenu.addPopupMenuListener(this);
		simpleMouseListener = new SimpleMouseListener(this);
		_popup.getComponent().addMouseListener(simpleMouseListener);
		popup = _popup;
	}

	public SimplePopup(IPopup _popup, Component [] components) {
		popupMenu = new SimplePopupMenu(this, _popup.getPopupMenuItem());
		popupMenu.addPopupMenuListener(this);
		simpleMouseListener = new SimpleMouseListener(this);
		for (int i=0; i<components.length; i++) {
			components[i].addMouseListener(simpleMouseListener);
		}
		popup = _popup;
	}

	public SimplePopup(IPopup _popup, FrameResource parser) {
		popupMenu = new SimplePopupMenu(this, parser);
		popupMenu.addPopupMenuListener(this);
		simpleMouseListener = new SimpleMouseListener(this);
		Component c = _popup.getComponent();
		if (c != null) { c.addMouseListener(simpleMouseListener); }
		popup = _popup;
	}

	public SimplePopup(IPopup _popup, Component [] components, FrameResource parser) {
		popupMenu = new SimplePopupMenu(this, parser);
		popupMenu.addPopupMenuListener(this);
		simpleMouseListener = new SimpleMouseListener(this);
		for (int i=0; i<components.length; i++) {
			components[i].addMouseListener(simpleMouseListener);
		}
		popup = _popup;
	}

	public void actionPerformed(ActionEvent e) {
		JMenuItem source = (JMenuItem)e.getSource();
		popup.doPopupMenuSelected(source);
	}


	public void doAction(SubMenuResource info) {
		popup.doPopupMenuSelected(info);
	}

    private boolean maybeShowPopup(MouseEvent e) {
        boolean bRet = false;
        popupMenu.setSelectedRow(0);
        if (popup.isShowOK(e)) {
            popupMenu.showpopup(e);
            popupMenu.requestFocus();
            bRet = true;
        }
        return bRet;
    }

	public void popupMenuWillBecomeVisible(PopupMenuEvent e) {
		popup.doPopupMenuVisible();
	}

	public void popupMenuWillBecomeInvisible(PopupMenuEvent e) {
		popup.getComponent().requestFocus(); 
	}

	public void popupMenuCanceled(PopupMenuEvent e) {
		popup.getComponent().requestFocus();
	}

	private class SimpleMouseListener extends MouseAdapter {
		private SimplePopup action = null;
		public SimpleMouseListener(SimplePopup _action) { action = _action; }
		public void mouseReleased(MouseEvent e) { action.maybeShowPopup(e); }
	}
	public void setPopupActionSource(Object object) {actionSource = object;  }
	public Object getPopupActionSource() {return actionSource;  }

	public int getComponentIndex(Component menuItem) {
		return popupMenu.getComponentIndex(menuItem);
	}
}
