package	jp.co.sds_corp.util.pooh.tools;

import java.io.File;
import java.util.Iterator;

import jp.co.sds_corp.util.pooh.menu.PopupResource;
import jp.co.sds_corp.util.pooh.menu.RootMenuResource;
import jp.co.sds_corp.util.pooh.menu.SubMenuResource;
import jp.co.sds_corp.util.xml.CmnXMLWriter;

import org.w3c.dom.Element;

public class OutputPopupResource extends CmnXMLWriter {

	private Element root = null;
	public OutputPopupResource() throws Exception {
		createDocument("gui");
	}

	public void setMenus() {
		root = createElement("menus");
	}

	public void setPartResource(RootMenuResource rmr) throws Exception {
		Element elm = createElement("menu");
		elm.setAttribute("name",      rmr.getName()); 
		subMenu(elm, rmr, rmr.getName());
		root.appendChild(elm);
	}

	public void writeResource(String file) throws Exception {
		getRoot().appendChild(root);
		printFile(new File(file));
	}

	public void setAllResource(String file, PopupResource mr) throws Exception {
		if (mr != null) {
			Iterator iterator = mr.iterator();
			setMenus();
			while (iterator.hasNext()) {
				RootMenuResource rmr = (RootMenuResource)iterator.next();
				setPartResource(rmr);
			}			
			writeResource(file);
		}
	}

	private void subMenu(Element e, RootMenuResource rmr, String key) throws Exception {
		Iterator iterator = rmr.iterator(key);
		if (iterator != null) {
			while (iterator.hasNext()) {
				SubMenuResource info = (SubMenuResource)iterator.next();
				Element ele = createElement("item");
				switch (info.getType()) {
					case SubMenuResource.MENU_SEPARATOR:
						ele.setAttribute("type", info.getSztype());
						e.appendChild(ele);
						break;
					case SubMenuResource.MENU_MENU:
						ele.setAttribute("type", info.getSztype());
						ele.setAttribute("name", info.getName());
						subMenu(ele, rmr, info.getName());
						e.appendChild(ele);
						break;
					case SubMenuResource.MENU_GROUP:
						ele.setAttribute("type", info.getSztype());
						ele.setAttribute("name", info.getName());
						subMenu(ele, rmr, info.getName());
						e.appendChild(ele);
						break;
					case SubMenuResource.MENU_CHECK:
					case SubMenuResource.MENU_RADIO:
					case SubMenuResource.MENU_NORMAL:
						elementSet(ele, info);
						e.appendChild(ele);
						break;
				}
			}
		}
	}

	private void elementSet(Element ele, SubMenuResource info) throws Exception {
		ele.setAttribute("name",     info.getName());
		ele.setAttribute("mnemonic", info.getSzmnemonic());
		ele.setAttribute("enable",   String.valueOf(info.getEnabled()));
		ele.setAttribute("selected", String.valueOf(info.getSelected()));
		ele.setAttribute("accelerator", String.valueOf(info.getAccelerator()));

		if (info.getSztype().length() > 0)
			ele.setAttribute("type", info.getSztype());
		if (info.getSzlistener().length() > 0)
			ele.setAttribute("listener", info.getSzlistener());
		if (info.getSzopen().length() > 0)
			ele.setAttribute("open",     info.getSzopen());
		if (info.getSzaction().length() > 0)
			ele.setAttribute("action",   info.getSzaction());
		if (info.getLink().length() > 0)
			ele.setAttribute("link",     info.getLink());
	}
}
