package	jp.co.sds_corp.util.pooh.top;

import java.awt.Component;
import java.awt.Rectangle;
import java.awt.Window;
import java.lang.reflect.Method;
import java.util.HashMap;
import java.util.Hashtable;
import java.util.Iterator;
import java.util.Map;

import javax.swing.JComponent;
import javax.swing.JMenuBar;
import javax.swing.JOptionPane;

import jp.co.sds_corp.util.pooh.frame.FrameManager;
import jp.co.sds_corp.util.pooh.menu.MenuManager;
import jp.co.sds_corp.util.pooh.menu.PopupParser;
import jp.co.sds_corp.util.pooh.menu.RootMenuResource;
import jp.co.sds_corp.util.pooh.prop.PropPageList;
import jp.co.sds_corp.util.pooh.simple.SimpleMdiFrame;

public class Toplevel extends Top {

	private String current_path;
	private String name;
	private Map userAttributes     = new Hashtable();
	private Map frameWorkAttribute = new Hashtable();
	private String resourcePath = null;
	public static final String VERSION      = "version";
	public static final String URL          = "url";
	public static final String COPYRIGHT    = "copyligth";
	public static final String PRODUCT      = "product";
	public static final String STATUS_BAR   = "statusBar";
	public static final String TOOL_BAR     = "toolBar";

	public Toplevel() {super();} 
	public void run(String pack) throws Exception {
		resourcePath = pack;
		current_path = getUserDir();
		DesktopParser parser = new DesktopParser(this, resourcePath);
		resource = parser.loadResource();
		loadProducts();
		loadObjects();
		topWin = (TopWindow)Class.forName(resource.getStart_object()).newInstance();
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI:
				((SimpleMdiFrame)topWin).setToplevel(this);
				((SimpleMdiFrame)topWin).defaultUIResource();
				((SimpleMdiFrame)topWin).initialFrame(resource.getStart_object_name());
    			runMDI((SimpleMdiFrame)topWin);
				break;
			case TopWindow.TYPE_SDI:
				break;
			case TopWindow.TYPE_DIALOG:
				break;
		}
	}

	public Rectangle getPreferredDialogRectangle(int x, int y, int w, int h) {
		int new_x, new_y, new_w, new_h;
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI:
				new_x = x + ((SimpleMdiFrame)topWin).getX() + 5;
				new_y = y + ((SimpleMdiFrame)topWin).getY() + 53;
				return new Rectangle(new_x, new_y, w, h);

			case TopWindow.TYPE_SDI: break;
			case TopWindow.TYPE_DIALOG: break;
		}
		return null;
	}

	public Rectangle getPreferredFrameRectangle(int x, int y, int w, int h) {
		int new_x, new_y, new_w, new_h;
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI:
				new_x = (x==-1) ? ((SimpleMdiFrame)topWin).getFrame_x(w) : x;
				new_y = (y==-1) ? ((SimpleMdiFrame)topWin).getFrame_y(h) : y;
				new_w = (w==-1) ? ((SimpleMdiFrame)topWin).getFrame_w()  : w;
				new_h = (h==-1) ? ((SimpleMdiFrame)topWin).getFrame_h()  : h;
				return new Rectangle(new_x, new_y, new_w, new_h);

			case TopWindow.TYPE_SDI: break;
			case TopWindow.TYPE_DIALOG: break;
		}
		return null;
	}
	
	private void loadProducts() throws Exception {
		setAttribute(Toplevel.VERSION, resource.getProducts().getVersion());
		setAttribute(Toplevel.URL, resource.getProducts().getUrl());
		setAttribute(Toplevel.COPYRIGHT, resource.getProducts().getCopyright());
		setAttribute(Toplevel.PRODUCT, resource.getProducts().getProduct());
	}

	private void loadObjects() throws Exception {
		Iterator iterator = resource.getLoadObjects().iterator();
		while (iterator.hasNext()) {
			LoadObjectInfo d = (LoadObjectInfo)iterator.next();
			Object obj = Class.forName(d.getObject_string()).newInstance();
			setAttribute(d.getName(), obj);
			Class [] clazz = {this.getClass()};
			Method m = obj.getClass().getMethod("setToplevel", clazz);
			Object [] params = { this };
			m.invoke(obj, params);
		}
	}

	//-------------------------------------------------------------------------------
	// FrameWork Used Attribute		
	//-------------------------------------------------------------------------------
	public void removePropertyPage(String key1, String key2) throws Exception {}
	public void removeAllPropertyPage(String key1) throws Exception {}
	public void setPropertyPage(String key, Object propPage) throws Exception {
		PropPageList o = (PropPageList)getAttribute(key);
		if (o == null) {
			o = new PropPageList();
			o.add(propPage);
			setAttribute(key, o);
		} else {
			o.add(propPage);
		}
	}
	public void removeAttribute(String key) throws Exception { frameWorkAttribute.remove(key); }
	public void setAttribute(String key, Object value) throws Exception {
		frameWorkAttribute.put(key, value);
	}
	public Object getAttribute(String key) { return frameWorkAttribute.get(key); }
	public void setProperty(String attribute, String name, Object value) throws Exception {
		Object bean   = frameWorkAttribute.get(attribute);
		PropertyUtils.setProperty(bean, name, value);
	}

	public Object getProperty(String attribute, String name) {
		try {
			Object bean   = frameWorkAttribute.get(attribute);
			return PropertyUtils.getProperty(bean, name);
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	//-------------------------------------------------------------------------------
	// User Used Attribute		
	//-------------------------------------------------------------------------------
	public void setUserAttribute(String key1, String key2, Object value) throws Exception {
		Map userAttribute = (Map)userAttributes.get(key1);
		if (userAttribute == null) {
			userAttribute = new HashMap();
		}
		userAttribute.put(key2, value);
		userAttributes.put(key1, userAttribute);
	}

	public Object getUserAttribute(String key1, String key2) throws Exception {
		Map userAttribute = (Map)userAttributes.get(key1);
		return userAttribute.get(key2);
	}

	public void removeUserAttribute(String key1, String key2) throws Exception {
		Map userAttribute = (Map)userAttributes.get(key1);
		if (userAttribute != null) {
			userAttribute.remove(key2);
		}
	}

	public void removeAllUserAttribute(String key1) throws Exception {
		userAttributes.remove(key1);
	}

	public void seUsertProperty(String key1, String attribute, String name, Object value)  
			throws Exception {
		Map userAttribute = (Map)userAttributes.get(key1);
		if (userAttribute != null) {
			Object bean   = userAttribute.get(attribute);
			PropertyUtils.setProperty(bean, name, value);
		}
	}

	public Object getUserProperty(String key1, String attribute, String name) {
		try {
			Map userAttribute = (Map)userAttributes.get(key1);
			if (userAttribute == null) {
				return null;
			} else {
				Object bean = userAttribute.get(attribute);
				return PropertyUtils.getProperty(bean, name);
			}
		} catch (Exception e) {
			e.printStackTrace();
		}
		return null;
	}

	//-----------------
	//
	//-----------------
	public void createDialog(String name) throws Exception {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI:
				((SimpleMdiFrame)topWin).createDialog(name);
				break;
			case TopWindow.TYPE_SDI: break;
			case TopWindow.TYPE_DIALOG: break;
		}
	}

	public void addWindow(JComponent comp) throws Exception {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI:
				(((SimpleMdiFrame)topWin).getDesktopPane()).add(comp);
				break;

			case TopWindow.TYPE_SDI: break;
			case TopWindow.TYPE_DIALOG: break;
		}
	}

	public void createFrame(String name) throws Exception {
		((SimpleMdiFrame)topWin).createFrame(name);
	}

	public void createFrame() throws Exception {
		((SimpleMdiFrame)topWin).createFrame();
	}

	public void exit() {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI:
				((SimpleMdiFrame)topWin).exit();
				break;
			case TopWindow.TYPE_SDI: break;
			case TopWindow.TYPE_DIALOG: break;
		}
	}

	public FrameManager getFrameManager() {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI: return ((SimpleMdiFrame)topWin).getFrameManager();
			case TopWindow.TYPE_SDI: return null;
			case TopWindow.TYPE_DIALOG: return null;
		}
		return null;
	}


	public MenuManager getMenuManager() throws Exception {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI: return ((SimpleMdiFrame)topWin).getMenuManager();
			case TopWindow.TYPE_SDI: return null;
			case TopWindow.TYPE_DIALOG: return null;
		}
		return null;	
	}

	public void initializ() throws Exception {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI: 
				((SimpleMdiFrame)topWin).initialFrame(name);
				menuChange();
				break;
			case TopWindow.TYPE_SDI: break;
			case TopWindow.TYPE_DIALOG: break;
		}
	}

	public Window getTopWindow() {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI: return (SimpleMdiFrame)topWin;
			case TopWindow.TYPE_SDI: return null;
			case TopWindow.TYPE_DIALOG: return null;
			default: return null;
		}
	}

	public Component getParentComponent() {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI: return (SimpleMdiFrame)topWin;
			case TopWindow.TYPE_SDI: return null;
			case TopWindow.TYPE_DIALOG: return null;
			default: return null;
		}
	}

	public JMenuBar getMenuBar() {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI: return ((SimpleMdiFrame)topWin).getJMenuBar();
			case TopWindow.TYPE_SDI: return null;
			case TopWindow.TYPE_DIALOG: return null;
			default: return null;
		}
	}

	public RootMenuResource getRootMenuResource(int idx) {
		switch (topWin.getWindowType()) {
			case TopWindow.TYPE_MDI: return ((SimpleMdiFrame)topWin).getRootMenuResource(idx);
			case TopWindow.TYPE_SDI: return null;
			case TopWindow.TYPE_DIALOG: return null;
			default: return null;
		}
	}

	public static String getUserDir() { return System.getProperty("user.dir"); }
	public TopWindow getFrame() { return topWin; }

	public java.net.URL getResource(String base, String ext) throws Exception {
		ClassLoader loader = getClass().getClassLoader();
		String path = (resourcePath + "." + base).replace('.', '/');
		return loader.getResource(path + "." + ext);
	}

	public boolean equals(String attribute, String name, String value) throws Exception {
		Object bean   = frameWorkAttribute.get(attribute);
		Object result = PropertyUtils.getProperty(bean, name);
		return value.equals(result.toString());
	}
	public String getResourcePath() { return resourcePath; }

	public boolean warningDialog(String message, String title, Object [] options, int def) {
		return JOptionPane.showOptionDialog(getParentComponent(),
					message, title, JOptionPane.DEFAULT_OPTION, JOptionPane.WARNING_MESSAGE,
					null, options, options[def])==JOptionPane.YES_OPTION;
	}

	public RootMenuResource getPopupResource(String fn) throws Exception {
		PopupParser parser = new PopupParser(this);
		return parser.loadResource(fn);
	} 
}
